﻿/*
Stores the timestamp and rmsValue of a 'knock' and provides some helper functions

*/

using UnityEngine;
using System.Collections;
using System;

public class Knock {
	
	private DateTime timestamp;
	private double rmsValue;

	private bool isStillValid = true;

	public Knock(double rmsValue)
	{
		this.rmsValue = rmsValue;
		this.timestamp = DateTime.Now;
	}

	public double getRmsValue()
	{
		return rmsValue;
	}

	public bool isOverThreshold(double threshold)
	{
		if (rmsValue > threshold)
			return true;
		else
			return false;
	}


	public bool isInTimeWindow(long timeWindow)
	{
		long timespan = (long)(DateTime.Now - timestamp).TotalMilliseconds;

		if (timespan < timeWindow)
		{
			return true;
		}
		else 
		{
			this.setInvalid();
			return false;
		}
	}


	public bool isValid()
	{
		return isStillValid;
	}

	public void setInvalid()
	{
		this.isStillValid = false;
	}

}
